"use strict";
"use client";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = require("react");
var window_1 = tslib_1.__importDefault(require("../../util/window"));
function useEventListener(eventType, callback, element, options) {
    if (element === void 0) { element = window_1.default; }
    var callbackRef = (0, react_1.useRef)(callback);
    (0, react_1.useEffect)(function () {
        callbackRef.current = callback;
    }, [callback]);
    (0, react_1.useEffect)(function () {
        if (element == null)
            return;
        var handler = function (e) { return callbackRef.current(e); };
        element.addEventListener(eventType, handler, options);
        return function () { return element.removeEventListener(eventType, handler); };
    }, [eventType, element]);
}
exports.default = useEventListener;
