"use strict";
"use client";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useSessionStorage = exports.useLocalStorage = void 0;
var tslib_1 = require("tslib");
var react_1 = require("react");
var window_1 = tslib_1.__importDefault(require("../../util/window"));
var useDebounce_1 = tslib_1.__importDefault(require("../useDebounce"));
function useStorage(key, defaultValue, storage) {
    var storageObject = (0, react_1.useMemo)(function () { return window_1.default === null || window_1.default === void 0 ? void 0 : window_1.default[storage]; }, []);
    var _a = (0, react_1.useState)(function () {
        var jsonValue = storageObject === null || storageObject === void 0 ? void 0 : storageObject.getItem(key);
        try {
            if (jsonValue !== null)
                return JSON.parse(jsonValue !== null && jsonValue !== void 0 ? jsonValue : "{}");
        }
        catch (e) {
        }
        finally {
            if (typeof defaultValue === "function") {
                return defaultValue();
            }
            else {
                return defaultValue;
            }
        }
    }), value = _a[0], setValue = _a[1];
    (0, useDebounce_1.default)(function () {
        if (!storageObject)
            return;
        if (value === undefined) {
            storageObject === null || storageObject === void 0 ? void 0 : storageObject.removeItem(key);
        }
        else {
            storageObject === null || storageObject === void 0 ? void 0 : storageObject.setItem(key, JSON.stringify(value));
        }
    }, 100, [key, value, storageObject]);
    var remove = (0, react_1.useCallback)(function () {
        setValue(undefined);
    }, []);
    return [value, setValue, remove];
}
exports.default = useStorage;
function useLocalStorage(key, defaultValue) {
    return useStorage(key, defaultValue, "localStorage");
}
exports.useLocalStorage = useLocalStorage;
function useSessionStorage(key, defaultValue) {
    return useStorage(key, defaultValue, "sessionStorage");
}
exports.useSessionStorage = useSessionStorage;
