"use client";
import { useState, useCallback } from "react";
import Cookies from "js-cookie";
export default function useCookie(name, defaultValue) {
    if (defaultValue === void 0) { defaultValue = ""; }
    var _a = useState(function () {
        var cookie = Cookies.get(name);
        if (cookie)
            return cookie;
        Cookies.set(name, defaultValue);
        return defaultValue;
    }), value = _a[0], setValue = _a[1];
    var updateCookie = useCallback(function (newValue, options) {
        Cookies.set(name, newValue, options);
        setValue(newValue);
    }, [name]);
    var deleteCookie = useCallback(function () {
        Cookies.remove(name);
        setValue(null);
    }, [name]);
    return [value, updateCookie, deleteCookie];
}
