"use client";
import { __assign } from "tslib";
import { useEffect, useRef } from "react";
import useRenderCount from "../useRenderCount";
export default function useDebugInformation(componentName, props) {
    var count = useRenderCount();
    var changedProps = useRef({});
    var previousProps = useRef(props);
    var lastRenderTimestamp = useRef(Date.now());
    var propKeys = Object.keys(__assign(__assign({}, props), previousProps));
    changedProps.current = propKeys.reduce(function (obj, key) {
        var _a;
        if (props[key] === previousProps.current[key])
            return obj;
        return __assign(__assign({}, obj), (_a = {}, _a[key] = { previous: previousProps.current[key], current: props[key] }, _a));
    }, {});
    var info = {
        count: count,
        changedProps: changedProps.current,
        timeSinceLastRender: Date.now() - lastRenderTimestamp.current,
        lastRenderTimestamp: lastRenderTimestamp.current,
    };
    useEffect(function () {
        previousProps.current = props;
        lastRenderTimestamp.current = Date.now();
        console.info("[debug-info]", componentName, info);
    });
    return info;
}
