/// <reference types="react" />
import { Callback } from "../../util";
type GoCallback = (index: number) => void;
export type HistoryOperationHook<T> = {
    history: T[];
    pointer: number;
    back: Callback;
    forward: Callback;
    go: GoCallback;
};
export type HistoryHook<T> = [
    T,
    React.Dispatch<React.SetStateAction<T>>,
    HistoryOperationHook<T>
];
export default function useStateWithHistory<T>(defaultValue: T, capacity?: number): HistoryHook<T>;
export {};
