import { StateSetter } from "../../util";
type TranslationKeys = {
    [key: string]: TranslationKeys | string | undefined;
};
type Translations = {
    [language: string]: TranslationKeys;
};
export type TranslationUseHook = (key: string) => string;
export type TranslationHook<L> = {
    language: L | string | undefined;
    setLanguage: StateSetter<L | string | undefined>;
    fallbackLanguage: L | string | undefined;
    setFallbackLanguage: StateSetter<L | string | undefined>;
    t: TranslationUseHook;
};
export default function useTranslation<L>(translations: Translations, defaultLanguage?: L | string): TranslationHook<L>;
export {};
